/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package View;
import Model.*;
import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import java.io.FileNotFoundException;


/**
 *
 * @author andre
 */
public class PGMFilter extends javax.swing.JFrame {

    /**
     * Creates new form PGMFilter
     */
    
    private File selected;
    private ArquivoPGMDeEscrita output;
    private ArquivoPGMDeLeitura input;
    private Filter filter;
    
    public PGMFilter() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("PGM FILTER");

        jButton1.setText("File...");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel2.setText("Original");

        jLabel3.setText("Alterada");

        jButton2.setText("Sharpen");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("Negative");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText("Smooth");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(145, 145, 145)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel3)
                .addGap(173, 173, 173))
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(198, 198, 198)
                        .addComponent(jButton3)
                        .addGap(18, 18, 18)
                        .addComponent(jButton2)
                        .addGap(18, 18, 18)
                        .addComponent(jButton4)))
                .addContainerGap(514, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addGap(84, 84, 84)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 684, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton2)
                    .addComponent(jButton3)
                    .addComponent(jButton4))
                .addGap(30, 30, 30))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter(
        "PGM", "pgm");
        chooser.setFileFilter(filter);
        int returnVal;
        returnVal = chooser.showOpenDialog(jLabel2);
        
        
        
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            
            this.selected = chooser.getSelectedFile();
            this.input = new ArquivoPGMDeLeitura(this.selected);
            try {
                this.input.lerArquivo();
            } catch (FileNotFoundException ex) {
                Logger.getLogger(PGMFilter.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(PGMFilter.class.getName()).log(Level.SEVERE, null, ex);
            }
            
            ImagePanel img = new ImagePanel(this.selected);
            
            ImageIcon icon = new ImageIcon(img.getImage());
            jLabel2.setIcon(icon);
            //img.paintComponent(getGraphics(), 50, 50);
           
                
//            BufferedImage pic;
//            try {
//                pic = ImageIO.read(new File(chooser.getSelectedFile().getAbsolutePath()));
//                ImageIcon icon = new ImageIcon(pic);
//                jLabel2.setIcon(icon);
//                jLabel2.setSize(255, 255);
//                jLabel3.setIcon(icon);
//            } catch (IOException ex) {
//                Logger.getLogger(PGMFilter.class.getName()).log(Level.SEVERE, null, ex);
//            }

 
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
        
        this.output = new ArquivoPGMDeEscrita();
        
        this.output.setAltura(this.input.getAltura());
        this.output.setLargura(this.input.getLargura());
        this.output.setMaximo(this.input.getMaximo());
        this.output.setComentario(this.input.getComentario());
        this.output.setP5(this.input.getP5());
        this.output.setPixels(null);
        
        this.filter = new Negativo();
        this.output.setPixels(this.filter.aplicaFiltro(this.input.getPixels(), this.input.getLargura(), this.input.getAltura(), this.input.getMaximo()));
        
        String path = this.input.getFile().toString();
        if(path.endsWith(".pgm")){
            path = path.replace(".pgm", "Neg.pgm");
        }
        
        try {
            this.output.escreverArquivo(path);
            //Save new File;
        } catch (IOException ex) {
            Logger.getLogger(PGMFilter.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        ImagePanel img = new ImagePanel(this.output.getFile());
            
        ImageIcon icon = new ImageIcon(img.getImage());
        jLabel3.setIcon(icon);
        
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        this.output = new ArquivoPGMDeEscrita();
        
        this.output.setAltura(this.input.getAltura());
        this.output.setLargura(this.input.getLargura());
        this.output.setMaximo(this.input.getMaximo());
        this.output.setComentario(this.input.getComentario());
        this.output.setP5(this.input.getP5());
        this.output.setPixels(null);
        
        this.filter = new Sharpen();
        this.output.setPixels(this.filter.aplicaFiltro(this.input.getPixels(), this.input.getLargura(), this.input.getAltura(), this.input.getMaximo()));
        
        String path = this.input.getFile().toString();
        if(path.endsWith(".pgm")){
            path = path.replace(".pgm", "SHA.pgm");
        }
        
        try {
            this.output.escreverArquivo(path);
            //Save new File;
        } catch (IOException ex) {
            Logger.getLogger(PGMFilter.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        ImagePanel img = new ImagePanel(this.output.getFile());
            
        ImageIcon icon = new ImageIcon(img.getImage());
        jLabel3.setIcon(icon);
        
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        // TODO add your handling code here:
        this.output = new ArquivoPGMDeEscrita();
        
        this.output.setAltura(this.input.getAltura());
        this.output.setLargura(this.input.getLargura());
        this.output.setMaximo(this.input.getMaximo());
        this.output.setComentario(this.input.getComentario());
        this.output.setP5(this.input.getP5());
        this.output.setPixels(null);
        
        this.filter = new Smooth();
        this.output.setPixels(this.filter.aplicaFiltro(this.input.getPixels(), this.input.getLargura(), this.input.getAltura(), this.input.getMaximo()));
        
        String path = this.input.getFile().toString();
        if(path.endsWith(".pgm")){
            path = path.replace(".pgm", "SMO.pgm");
        }
        
        try {
            this.output.escreverArquivo(path);
            //Save new File;
        } catch (IOException ex) {
            Logger.getLogger(PGMFilter.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        ImagePanel img = new ImagePanel(this.output.getFile());
            
        ImageIcon icon = new ImageIcon(img.getImage());
        jLabel3.setIcon(icon);
    }//GEN-LAST:event_jButton4ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(PGMFilter.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(PGMFilter.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(PGMFilter.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(PGMFilter.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new PGMFilter().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    // End of variables declaration//GEN-END:variables
}
